echo off
title Building HDoom Source
cls

if not exist acs (
	mkdir acs
)

if not exist ir (
	mkdir ir
)

if not exist acs\libc.bin (
	echo Building libc . . . 
	gdcc-makelib --bc-target=ZDoom libc -c -o ir/libc.ir
	gdcc-makelib --bc-target=ZDoom libGDCC -c -o ir/libGDCC.ir
	gdcc-ld --bc-target=ZDoom --bc-zdacs-init-delay --alloc-min Sta "" 1000000000 ir/libc.ir ir/libGDCC.ir acs/libc.bin
)

echo Building C code . . . 
gdcc-cc --bc-target=ZDoom -c source/*.c --sys-include source ir/hdoom.ir
gdcc-ld --bc-target=ZDoom --bc-zdacs-init-delay -llibc ir/hdoom.ir acs/hdoom.bin

echo Compiling ACS scripts . . . 
gdcc-acc -lhdoom scripts/main.acs acs/hscripts.bin

echo Compiling VNS scripts . . . 
for %%f in (vns/*.vns) do (
	vnsc "vns/%%f"
)

echo Done.
echo Press any key to exit . . . 
pause >nul
