#define ACS_SHORT_NAMES

#include <ACS_ZDoom.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdbool.h>
#include "defs.h"
#include "utility.h"

char *astrtoc(str s)
{
	static char *buf;
	static size_t alloc;
	size_t len = StrLen(s) + 1;
	if (alloc < len)
		buf = realloc(buf, len);
	for (size_t i = 0; i != len; ++i)
		buf[i] = s[i];
	return buf;
}

str astrupper(str s)
{
	int len = StrLen(s);
	BeginStrParam();
	for (int i = 0; i < len; i++)
	{
		char c = GetChar(s, i);
		__nprintf("%c", toupper(c));
	}
	return EndStrParam();
}

str astrlower(str s)
{
	int len = StrLen(s);
	BeginStrParam();
	for (int i = 0; i < len; i++)
	{
		char c = GetChar(s, i);
		__nprintf("%c", tolower(c));
	}
	return EndStrParam();
}

int astrtoi(str s)
{
	return strtol_str(s, NULL, 10);
}

void FreezePlayer()
{
	SetActorVelocity(0, 0, 0, GetActorVelZ(0), false, true);
	SetPlayerProperty(0, 1, PROP_TOTALLYFROZEN);
}

void UnFreezePlayer()
{
	SetPlayerProperty(0, 0, PROP_TOTALLYFROZEN);
}

double GetAspectRatio()
{
	int aspect        = GetCVar(s"vid_aspect");
	double width      = GetCVarFixed(s"vid_defwidth");
	double height     = GetCVarFixed(s"vid_defheight");
	bool nowidescreen = GetCVar(s"vid_nowidescreen");
	bool tft          = GetCVar(s"vid_tft");
	
	if (nowidescreen)
	{
		if (!tft)
			return ASPECT_4_3;
		if (height * ASPECT_5_4 == width)
			return ASPECT_5_4;
		else
			return ASPECT_4_3;
	}
	
	switch(aspect)
	{
		case 1: return ASPECT_16_9;
		case 2: return ASPECT_16_10;
		case 3: return ASPECT_4_3;
		case 4: return ASPECT_5_4;
		case 5: return ASPECT_17_10;
	}
	
	return width / height;
}

double GetAspectScale()
{
	// Return ASPECT_4_3 for crop
	// Return GetAspectRatio() / ASPECT_4_3 for scale
	return 1 / (GetAspectRatio() / ASPECT_4_3);
}

bool KeyPressed(int k)
{
	int input     = GetPlayerInput(-1, INPUT_BUTTONS);
	int old_input = GetPlayerInput(-1, INPUT_OLDBUTTONS);
	
	if ((input & k) && !(old_input & k))
		return true;
	return false;
}

bool KeyReleased(int k)
{
	int input     = GetPlayerInput(-1, INPUT_BUTTONS);
	int old_input = GetPlayerInput(-1, INPUT_OLDBUTTONS);
	
	if (!(input & k) && (old_input & k))
		return true;
	return false;
}
